﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Kratos_3
Imports Kratos_3.Network
Imports Kratos_3.RunTimePlatform

Module Main

    Private Sub printOutFactletResults(df As DataFrame, fsod As FactSetOnDemand)
        If df.hasError() Then
            df.throwErrorIfAnyIsPresent()
        End If
        Console.WriteLine(fsod.GetEventLogger().getOutputBuffer())
        'Print a summary string
        Dim types As Type() = df.getDotNetColumnTypes()
        For row As Integer = 0 To df.getNumberOfRows() - 1
            For col As Integer = 0 To df.getNumberOfColumns() - 1
                Dim o As [Object] = df.getCellAt(row, col)
                ' Note that we know what the type of this cell is, so we could cast it or treat it as its proper type if we needed to
                Console.WriteLine("Row: " & row & ", Col: " & col & ", Value: " & o.ToString())
            Next
        Next
    End Sub

    Sub Main()
        Dim fsod = New FactSetOnDemand()
        Dim df As DataFrame

        ' Set our configuration. We definitely need to set our username and password, as given to us by FactSet Support staff
        Dim config As IConfigManager = fsod.getConfig()

        config.setConfig(ConfigOptions.DataDirectUserName, <INSERTUSERNAMEHERE>)
        config.setConfig(ConfigOptions.DataDirectPassword, <insertpwhere>)

        Dim uFactlet As New UploadFactlet("TestOFDB_CSharp", New String() {"ID", "Date", "my_price", "my_volume"}, New String() {"Id", "Date", "Double", "Double"})
        Dim dates As String() = {"04/10/2013", "04/11/2013", "04/12/2013"}
        Dim fds_price As Double() = {93.33, [Double].NaN, 92.65}
        Dim fds_volume As Double() = {388.205, [Double].NaN, 359.396}
        Dim xom_price As Double() = {88.68, [Double].NaN, 89.22}
        Dim xom_volume As Double() = {14826.0, [Double].NaN, 14980.0}
        For i As Integer = 0 To dates.Length - 1
            uFactlet.addDataPoint("FDS")
            uFactlet.addDataPoint(dates(i))
            uFactlet.addDataPoint(fds_price(i))
            uFactlet.addDataPoint(fds_volume(i))
        Next
        For i As Integer = 0 To dates.Length - 1
            uFactlet.addDataPoint("XOM")
            uFactlet.addDataPoint(dates(i))
            uFactlet.addDataPoint(xom_price(i))
            uFactlet.addDataPoint(xom_volume(i))
        Next
        df = fsod.executeFactlet(uFactlet)
        Console.WriteLine(fsod.GetEventLogAsString())

        df.throwErrorIfAnyIsPresent()

        ' In this example, we will run ExtractFormulaHistory and examine the unique
        ' IDs and Dates in the returned data
        df = fsod.ExtractFormulaHistory("xom,stl-no,fds,ibm,efc,appl,goog", "fg_eps(0,-1m,d)", "")
        printOutFactletResults(df, fsod)

        ' Extract Benchmark Detail
        df = fsod.ExtractBenchmarkDetail("SP50", "items", "FG_COMPANY_NAME,FG_MKT_VALUE")
        printOutFactletResults(df, fsod)

        df = fsod.ExtractBenchmarkDetail("SP50", "items", "p_price,proper_name", New String() {"cutoff", "10"})
        printOutFactletResults(df, fsod)

        df = fsod.ExtractBenchmarkDetail("SP50", "items", "p_price", New String() {"dates", "20110115:20110120:d"})
        printOutFactletResults(df, fsod)

        Console.Write("Press enter to continue")
        Dim name = Console.ReadLine()
    End Sub
End Module